package cn.wise.sc.energy.power.plant.business.task;

import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.context.annotation.DependsOn;
import org.springframework.stereotype.Component;
import javax.websocket.OnClose;
import javax.websocket.OnError;
import javax.websocket.OnMessage;
import javax.websocket.OnOpen;
import javax.websocket.Session;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;
import java.io.IOException;
import java.util.UUID;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @description: 首页实时数据
 * @author: qh
 * @create: 2020-08-18 12:18
 **/
@Slf4j
@Component
@DependsOn("myApplicationContextAware")
@ServerEndpoint("/index/{plantCode}/{deviceId}")
public class IndexSystemWebSocket {

    /**
     * 静态变量，用来记录当前在线连接数。应该把它设计成线程安全的。
     */
    private static int onlineCount = 0;
    /**
     * concurrent包的线程安全Set，用来存放每个客户端对应的MyWebSocket对象。
     */
    public static ConcurrentHashMap<String, IndexSystemWebSocket> webSocketMap = new ConcurrentHashMap<>();
    public static ConcurrentHashMap<String, String> deviceMap = new ConcurrentHashMap<>();
    public static ConcurrentHashMap<String, String> plantCodeMap = new ConcurrentHashMap<>();
    /**
     * 与某个客户端的连接会话，需要通过它来给客户端发送数据
     */
    private Session session;
    private String uuid;

    /**
     * 连接建立成功调用的方法
     */
    @OnOpen
    public void onOpen(Session session, @PathParam("plantCode") String plantCode,
                       @PathParam("deviceId") String deviceId) {
        this.session = session;
        uuid = UUID.randomUUID().toString();
        if (StrUtil.isNotBlank(plantCode)) {
            deviceMap.put(uuid, deviceId);
        }
        webSocketMap.put(uuid, this);
        plantCodeMap.put(uuid, plantCode);
        //加入set中
        addOnlineCount();
        log.info("用户连接:" + deviceId + ",当前在线人数为:" + getOnlineCount());
    }

    /**
     * 连接关0---闭调用的方法
     */
    @OnClose
    public void onClose() {
        if (webSocketMap.containsKey(uuid)) {
            webSocketMap.remove(uuid);
            //从set中删除
            subOnlineCount();
        }
        log.info("用户退出:" + uuid + ",当前在线人数为:" + getOnlineCount());
    }

    /**
     * 收到客户端消息后调用的方法
     *
     * @param message 客户端发送过来的消息
     */
    @OnMessage
    public void onMessage(String message, Session session) throws IOException {
        log.info("用户消息:" + uuid + ",报文:" + message);
        //可以群发消息
        //消息保存到数据库、redis
        if (StringUtils.isNotBlank(message)) {
            webSocketMap.get(uuid).sendMessage("111111111");
        }
    }

    /**
     * @param session
     * @param error
     */
    @OnError
    public void onError(Session session, Throwable error) {
        log.error("用户错误:" + this.uuid + ",原因:" + error.getMessage());
        error.printStackTrace();
    }

    /**
     * 实现服务器主动推送
     */
    public void sendMessage(String message) throws IOException {
        this.session.getBasicRemote().sendText(message);
    }


    /**
     * 发送自定义消息
     */
    public static void sendInfo(String message, @PathParam("userId") String userId) throws IOException {
        log.info("发送消息到:" + userId + "，报文:" + message);
        if (StringUtils.isNotBlank(userId) && webSocketMap.containsKey(userId)) {
            webSocketMap.get(userId).sendMessage(message);
        } else {
            log.error("用户" + userId + ",不在线！");
        }
    }

    public static synchronized int getOnlineCount() {
        return onlineCount;
    }

    public static synchronized void addOnlineCount() {
        IndexSystemWebSocket.onlineCount++;
    }

    public static synchronized void subOnlineCount() {
        IndexSystemWebSocket.onlineCount--;
    }
}
